// Generated by CoffeeScript 2.4.1
(function() {
  var Redis, connect_redis, pkg, session,
    hasProp = {}.hasOwnProperty;

  pkg = require('./package.json');

  this.name = 'spicy-action:app';

  connect_redis = require('connect-redis');

  session = require('express-session');

  Redis = require('ioredis');

  module.exports = async function(cfg, local) {
    var auth_module, i, len, modules, ref, ref1, ref2, ref3, session_client, session_redis, session_store;
    this.use({
      helmet: (ref = local.security) != null ? ref : {}
    });
    this.helper({cfg, pkg});
    this.cfg = cfg;
    this.helper({
      user_data: function() {
        var k, ref1, ref2, ref3, ref4, ref5, ref6, ref7, ref8, ref9, res, v;
        res = {
          ok: ((ref1 = this.req.session) != null ? ref1.couchdb_token : void 0) != null,
          username: (ref2 = this.req.session) != null ? ref2.couchdb_username : void 0,
          full_name: (ref3 = this.req.session) != null ? ref3.full_name : void 0,
          roles: (ref4 = this.req.session) != null ? ref4.couchdb_roles : void 0,
          admin: (ref5 = this.req.session) != null ? ref5.admin : void 0,
          locale: (ref6 = this.req.session) != null ? ref6.locale : void 0,
          timezone: (ref7 = this.req.session) != null ? ref7.timezone : void 0
        };
        if (((ref8 = this.req.session) != null ? ref8.user_params : void 0) != null) {
          ref9 = this.req.session.user_params;
          for (k in ref9) {
            if (!hasProp.call(ref9, k)) continue;
            v = ref9[k];
            if (res[k] == null) {
              res[k] = v;
            }
          }
        }
        return res;
      }
    });
    // Authentication, Authorization, Token
    // ------------------------------------

    // Authorization is provided against different backends.
    this.auth = [];
    modules = [
      // Authenticate and authorize (against CouchDB backend) ...
      './couchdb-auth',
      // ... and create token (required to prevent double-auth).
      './create-token',
      // Validate that a proper session was created.
      './auth-required'
    ];
    if (local.auth != null) {
      // Authenticate, authorize, and create token using local (private) methods.
      modules.unshift(local.auth);
    }
    for (i = 0, len = modules.length; i < len; i++) {
      auth_module = modules[i];
      if (typeof auth_module === 'string') {
        auth_module = require(auth_module);
      }
      if (auth_module.include != null) {
        await this.include(auth_module);
      }
      if (auth_module.middleware != null) {
        this.auth.push(this.wrap(auth_module.middleware));
      }
    }
    // Session
    // -------

    // Express: Store our session in Redis so that we can offload the Socket.IO piece to a different server if needed.
    session_redis = (ref1 = cfg.session_redis) != null ? ref1 : cfg.redis;
    if ((session_redis != null) && (cfg.session_secret != null)) {
      session_store = connect_redis(session);
      session_client = new Redis(session_redis);
      this.use(session({
        store: new session_store({
          client: session_client
        }),
        secret: cfg.session_secret,
        resave: true,
        unset: 'destroy',
        saveUninitialized: true,
        cookie: {
          maxAge: (ref2 = cfg.session_maxage) != null ? ref2 : 30 * 60 * 1000,
          secure: (ref3 = cfg.session_secure) != null ? ref3 : true
        }
      }));
    }
    if (local.public != null) {
      // Local services
      // --------------

      // Order is important here, since these services may fallback to using the `public_proxy` versions with `next 'route'`.
      await this.include(local.public);
    }
    this.get('/', function() {
      return this.json({
        ok: true,
        name: pkg.name,
        version: pkg.version,
        local: local.pkg.version
      });
    });
  };

}).call(this);
