// Generated by CoffeeScript 2.4.1
(function() {
  // Validate the session
  // --------------------

  // The session is validated by ensuring that both the username and the roles array are populated.
  var create_token, crypto, hex_hmac_sha1;

  this.middleware = create_token = function() {
    if (this.req.session.couchdb_token != null) {
      return;
    }
    if (!((this.req.session.couchdb_username != null) && (this.req.session.couchdb_roles != null))) {
      this.req.session.couchdb_username = null;
      this.req.session.couchdb_roles = null;
      return;
    }
    if (this.cfg.couchdb_secret == null) {
      return;
    }
    this.req.session.couchdb_token = hex_hmac_sha1(this.cfg.couchdb_secret, this.req.session.couchdb_username);
  };

  crypto = require('crypto');

  hex_hmac_sha1 = function(key, value) {
    var hmac;
    hmac = crypto.createHmac('sha1', key);
    hmac.update(value);
    return hmac.digest('hex');
  };

}).call(this);
