// Generated by CoffeeScript 2.4.1
(function() {
  // Multiple-backends interface for CouchDB
  // =======================================
  var make_couchdb_proxy, make_proxy,
    hasProp = {}.hasOwnProperty;

  make_proxy = require('./make_proxy');

  module.exports = make_couchdb_proxy = function(...bases) {
    var proxy;
    proxy = make_proxy(...bases);
    return function() {
      var headers, k, ref, v;
      headers = {};
      ref = this.request.headers;
      for (k in ref) {
        if (!hasProp.call(ref, k)) continue;
        v = ref[k];
        headers[k] = v;
      }
      // Using [proxy authentication](http://docs.couchdb.org/en/latest/api/server/authn.html#api-auth-proxy) in CouchDB.
      headers['X-Auth-CouchDB-Roles'] = this.req.session.couchdb_roles.join(',');
      headers['X-Auth-CouchDB-Token'] = this.req.session.couchdb_token;
      headers['X-Auth-CouchDB-UserName'] = this.req.session.couchdb_username;
      return proxy.call(this, headers);
    };
  };

}).call(this);
