// Generated by CoffeeScript 2.4.1
(function() {
  var integer, make_proxy, ref, ref1, request;

  request = require('request');

  make_proxy = function(...bases) {
    if ((bases[0] != null) && Array.isArray(bases[0])) {
      bases = bases[0];
    }
    return function(headers) {
      var failover, report;
      // Report error to the next middleware.
      report = (error) => {
        this.res.status(504);
        this.res.end();
      };
      // Failover
      // ========
      failover = (index, error) => {
        var base, proxy, timeout, url;
        // Note: The error may be `null` or irrelevant.

        // We keep going until we run out of backends to query.
        if (!(index < bases.length)) {
          report(error);
          return;
        }
        base = bases[index];
        index++;
        // Skip `null` entries
        if (base == null) {
          failover(index, error);
          return;
        }
        url = `${base}${this.request.url}`;
        if (index < bases.length) {
          timeout = module.exports.timeout;
        } else {
          timeout = module.exports.last_timeout;
        }
        proxy = request({
          method: this.request.method,
          url: url,
          headers: headers, // .set headers
          followRedirects: false, // .redirects 0
          maxRedirects: 0,
          strictSSL: false, // .agent false
          timeout: timeout
        });
        // Initial request attempt to the first backed: pipe the request to the server.
        // In case of error (assuming network error, hence the request was not piped yet), attempt to pipe to the failover server (if any).
        this.request.pipe(proxy).on('error', function(error) {
          return failover(index, error);
        });
        // Pipe the response back to the client.
        proxy.pipe(this.response);
      };
      // We do not catch errors on the response: it's too late anyhow.
      failover(0, new Error('No backend available'));
    };
  };

  module.exports = make_proxy;

  integer = function(n) {
    var v;
    v = parseInt(n, 10);
    if (isNaN(v)) {
      return null;
    } else {
      return v;
    }
  };

  module.exports.timeout = (ref = integer(process.env.TIMEOUT)) != null ? ref : 2000;

  module.exports.last_timeout = (ref1 = integer(process.env.LAST_TIMEOUT)) != null ? ref1 : 100000;

}).call(this);
