// Generated by CoffeeScript 2.4.1
(function() {
  this.include = function() {
    var base, couchdb_proxy, couchdb_urls, make_couchdb_proxy, ref, ref1, ref2, ref3, ref4;
    make_couchdb_proxy = require('./make_couchdb_proxy');
    // * cfg.proxy_base (URL or array of URLs, without authentication) Servers and ports used to build proxies for various services.

    // User databases.
    couchdb_urls = /^\/u[a-f\d]{8}-[a-f\d]{4}-[a-f\d]{4}-[a-f\d]{4}-[a-f\d]{12}($|\/)/;
    base = this.cfg.proxy_base;
    if (base != null) {
      couchdb_proxy = make_couchdb_proxy(base);
      this.get(couchdb_urls, this.auth, couchdb_proxy);
      this.post(couchdb_urls, this.auth, couchdb_proxy);
      this.put(couchdb_urls, this.auth, couchdb_proxy);
      this.delete(couchdb_urls, this.auth, couchdb_proxy);
    }
    // Provisioning and ruleset(s) databases.

    // * cfg.provisioning_base (URL or array of URLs, without_authentication) Servers and ports used to build proxies for provisioning and rulesets. Default: cfg.proxy_base
    couchdb_urls = /^\/(provisioning|plans|ruleset_[\w-]+|rates-[\w-]+|cdr-[\w_-]+|trace-[\w-]+|reference-[\w-]+)\//;
    base = (ref = this.cfg.provisioning_base) != null ? ref : this.cfg.proxy_base;
    if (base != null) {
      couchdb_proxy = make_couchdb_proxy(base);
      this.get('/provisioning', this.auth, couchdb_proxy);
      this.get('/plans', this.auth, couchdb_proxy);
      this.get('/ruleset_[\w-]+', this.auth, couchdb_proxy);
      this.get('/rates-[\w-]+', this.auth, couchdb_proxy);
      this.get('/cdr-[\w-]+', this.auth, couchdb_proxy);
      this.get('/trace-[\w-]+', this.auth, couchdb_proxy);
      this.get('/reference-[\w-]+', this.auth, couchdb_proxy);
      this.get(couchdb_urls, this.auth, couchdb_proxy);
      this.post(couchdb_urls, this.auth, couchdb_proxy);
      this.put(couchdb_urls, this.auth, couchdb_proxy);
      this.delete(couchdb_urls, this.auth, couchdb_proxy);
    }
    // Tools.

    // * cfg.tools_base (URL or array of URLs, without_authentication) Servers and ports used to build proxies for tools. Default: cfg.proxy_base
    base = (ref1 = this.cfg.tools_base) != null ? ref1 : this.cfg.proxy_base;
    if (base != null) {
      couchdb_proxy = make_couchdb_proxy(base);
      this.get(/^\/tools\//, this.auth, couchdb_proxy);
    }
    // Logging, used for traces.

    // * cfg.logging_base (URL or array of URLs, without_authentication) Servers and ports used to build proxies for logging. Default: cfg.proxy_base
    base = (ref2 = this.cfg.logging_base) != null ? ref2 : this.cfg.proxy_base;
    if (base != null) {
      couchdb_proxy = make_couchdb_proxy(base);
      this.get(/^\/logging\//, this.auth, couchdb_proxy);
    }
    // FreeSwitch-generated, carrier-side CDRs.

    // * cfg.cdrs_base (URL or array of URLs, without_authentication) Servers and ports used to build proxies for cdrs and cdrs-client. Default: cfg.proxy_base
    base = (ref3 = this.cfg.cdrs_base) != null ? ref3 : this.cfg.proxy_base;
    if (base != null) {
      couchdb_proxy = make_couchdb_proxy(base);
      this.get('/cdrs', this.auth, couchdb_proxy);
      this.post('/cdrs/_all_docs', this.auth, couchdb_proxy);
      this.post(/^\/cdrs\/_design\/\w+\/_view/, this.auth, couchdb_proxy);
      this.get(/^\/cdrs\//, this.auth, couchdb_proxy);
    }
    // FreeSwitch-generated, client-side CDRs.
    base = (ref4 = this.cfg.cdrs_base) != null ? ref4 : this.cfg.proxy_base;
    if (base != null) {
      couchdb_proxy = make_couchdb_proxy(base);
      this.get('/cdrs-client', this.auth, couchdb_proxy);
      this.post('/cdrs-client/_all_docs', this.auth, couchdb_proxy);
      this.post(/^\/cdrs-client\/_design\/\w+\/_view/, this.auth, couchdb_proxy);
      this.get(/^\/cdrs-client\//, this.auth, couchdb_proxy);
    }
  };

}).call(this);
